/* grnet (c) 2001 Brad Spengler */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/time.h>
#include <unistd.h>

char bytecounter[16];
struct ifaces {
	char ifname[8];
	float rcv;
	float snd;
} iface[15], ifacenew[15];
int ifacecnt=0;

const char * convert( float bytes )
{
	
	if( bytes > 1000000000 )
		snprintf(bytecounter,sizeof(bytecounter),"%.2fG",bytes / 1000000000.0);
	else if( bytes > 1000000 )
		snprintf(bytecounter,sizeof(bytecounter),"%.2fM",bytes / 1000000.0);
	else if( bytes > 1000 )
		snprintf(bytecounter,sizeof(bytecounter),"%.2fK",bytes / 1000.0);
	else
		snprintf(bytecounter,sizeof(bytecounter),"%.0f",bytes);
	return bytecounter;	
}

void parseent(void)
{

char buf[1024];
int i;
char *p,*p2;
FILE *devent;

devent = fopen("/proc/net/dev","r");

while(fgets(buf,sizeof(buf),devent)) {
	if(strchr(buf,':')) {
		p = strchr(buf,':');
		*p = '\0';
		p++;
		strncpy(iface[ifacecnt].ifname,buf,sizeof(iface[ifacecnt].ifname));	
		while(*p == ' ') p++;
		p2 = strchr(p,' ');
		*p2 = '\0';
		p2++;
		iface[ifacecnt].rcv = atof(p);
		for(i=0;i<8;i++) {
			while(*p2 == ' ') p2++;
			p = strchr(p2,' ');
			if (i != 7)
				p2 = p;
		}
		*p = '\0';
		iface[ifacecnt].snd = atof(p2);	
		ifacecnt++;
	}
}

fclose(devent);

}

int main(void) 
{
struct timeval tv;
float rcvold[8], sndold[8];
float totalrcv = 0,totalsnd = 0;
long before, after;
int i;

gettimeofday(&tv,NULL);
before = tv.tv_usec;
parseent();
for(i=0;i<ifacecnt;i++) {
	rcvold[i] = iface[i].rcv;
	sndold[i] = iface[i].snd;
}
sleep(10);
gettimeofday(&tv,NULL);
after = tv.tv_usec;
ifacecnt=0;
parseent();
printf("                       |grnet|                       \n");
printf("|---------------------------------------------------|\n");
printf("|Interface| Received|     Sent| Rcv Speed| Snd Speed|\n");
printf("|--------- --------- --------- ---------- ----------|\n");
for(i=0;i<ifacecnt;i++) {
	printf("|%9s|",iface[i].ifname);
	printf("%9s|",convert(iface[i].rcv));
	printf("%9s|",convert(iface[i].snd));
	printf("%7sb/s|",convert((1000 * (iface[i].rcv - rcvold[i])) / (after - before)));
	printf("%7sb/s|\n",convert((1000 * (iface[i].snd - sndold[i])) / (after - before)));
}
printf("|--------- --------- --------- ---------- ----------|\n");
printf("|    TOTAL|");

for(i=0;i<ifacecnt;i++)
	totalrcv += iface[i].rcv;
printf("%9s|", convert(totalrcv));
for(i=0;i<ifacecnt;i++)
	totalsnd += iface[i].snd;
printf("%9s|", convert(totalsnd));
totalrcv=0;
totalsnd=0;
for(i=0;i<ifacecnt;i++)
	totalrcv += ((1000.0 * (iface[i].rcv - rcvold[i])) / (after - before));
printf("%7sb/s|", convert(totalrcv));
for(i=0;i<ifacecnt;i++)
	totalsnd += ((1000.0 * (iface[i].snd - sndold[i])) / (after - before));
printf("%7sb/s|\n", convert(totalsnd));
printf("|___________________________________________________|\n");

return 0;
}
